src/website/controllers/blueprint.py
import json
import requests
from flask import Blueprint, render_template, request, url_for, redirect, current_app as app
from flask_login import current_user, login_required

from server.entities.atcratings import ATCRating

from ..atcmentoring import find_mentor_by_trainee
from ..auth import group_required, get_user_for_cid, save_user

from server.entities.atcratings import ATCRating

from . import entities
from . import data

bp = Blueprint('controllers', __name__, template_folder='templates', url_prefix='/controllers')

@bp.route("/scheduling")
def scheduling():
    atcsessions = list(data.get_atcsessions(app.db))
    for i, session in enumerate(atcsessions):
        atcsessions[i] = entities.to_calendar_format(session)
    return render_template(
        "controllers/scheduling.html",
        scheduling=atcsessions)

@bp.route("/sessions/delete", methods=["POST"])
@login_required
def atcsessionsdeletepage():
    data.remove_atcsession(app.db, request.form['sessionid'])
    return redirect(url_for('dashboard'))

@bp.route("/sessions/new", methods=["GET", "POST"])
@login_required
def newsession():
    #TODO:
    #Use flask_forms to remove this
    def valid_form(form):
        if form['startsdate'] == '':
            raise Exception("Starts date in fault!")
        elif form['endsdate'] == '':
            raise Exception("Ends date in fault!")
        elif form['startstime'] == '':
            raise Exception("Starts time in fault!")
        elif form['endstime'] == '':
            raise Exception("Ends time in fault!")
    mentors = data.get_trainee_mentors(app.db, current_user.cid)
    atcpositions = data.get_atcpositions_until_rating(
        app.db, current_user['atc_rating_id'])
    training_atcpositions =  data.get_training_atcpositions_until_rating(
        app.db, current_user['atc_rating_id'])
    view = { 'error':None, 'atcpositions':atcpositions,
        'training_atcpositions':training_atcpositions, 'mentors':mentors }
    if request.method == 'POST':
        try:
            valid_form(request.form)
            _position = entities.get_user_position_by_type(
                request.form['type'],
                request.form['position'],
                request.form['training_position'],
            )
            session = entities.create_atcsession(
                int(request.form['cid']),
                request.form['type'],
                _position,
                request.form['startsdate'], request.form['endsdate'],
                request.form['startstime'], request.form['endstime'],
                request.form['mentor'] if 'mentor' in request.form else None,
            )
            if data.can_add_session(app.db, session):
                data.add_session(app.db, session)
                return redirect(url_for('controllers.scheduling'))
            view['error'] = 'Other session already booked on this time.'
        except Exception as ex:
            view['error'] = ex
    return render_template("controllers/new_session.html", **view)

@bp.route("/positions")
@login_required
def positions():
    _atcpositions = data.get_atcpositions(app.db)
    view = {'atcpositions': _atcpositions, 'atcratings':ATCRating}
    return render_template("controllers/positions.html", **view)

@bp.route("/positions/set", methods=["GET", "POST"])
@login_required
@group_required('admin', 'atcpositions_editor')
def setposition():
    if request.method == 'POST':
        _position = entities.create_atcposition(
            request.form["position"],
            request.form["identifier"],
            request.form['frequency'],
            request.form['limit']
        )
        data.save_atcposition(app.db, _position)
        return redirect(url_for('controllers.positions'))
    return render_template('controllers/set_position.html')

@bp.route("/<int:cid>/certifications")
@login_required
@group_required('admin', 'training_director')
def usercertifications(cid):
    user = get_user_for_cid(app.db, cid)
    view = {'user': user}
    return render_template("controllers/user_certifications.html", **view)

@bp.route("/<int:cid>/certifications/add", methods=["GET", "POST"])
@login_required
@group_required('admin', 'training_director')
def add_certification(cid):
    if request.method == 'POST':
        _user = get_user_for_cid(app.db, cid)
        _certification = entities.create_certification(
            cid, request.form['certification'], current_user.cid)
        entities.add_certification(_user, _certification)
        save_user(app.db, _user)
        return redirect(url_for('controllers.usercertifications', cid=cid))
    user = get_user_for_cid(app.db, cid)
    _atcpositions = data.get_atcpositions_until_rating(app.db, user['vatsim']['rating']['id'])
    non_granted_positions = data.get_atcpositions_not_granted(app.db, cid)
    view = {'user': user, 'positions':non_granted_positions}
    return render_template("controllers/add_certification.html", **view)

@bp.route("/<int:cid>/certifications/delete", methods=["POST"])
@login_required
@group_required('admin', 'training_director')
def delete_certification(cid):
    _user = get_user_for_cid(app.db, cid)
    _icao = request.form['certification']
    entities.remove_certification(_user, _icao)
    save_user(app.db, _user)
    return redirect(url_for('controllers.usercertifications', cid=cid))

src/website/teamspeak/routes.py
from flask import Blueprint, render_template, redirect, url_for
from flask_login import current_user as user, login_required
from os import environ

from .teamspeak import Client, TeamSpeakService
from ts3.query import TS3QueryError

bp = Blueprint('teamspeak', __name__, template_folder='templates')

@bp.route('/register', methods=['POST'])
@login_required
def register():
    title = 'Registration error'

    try:
        teamspeak = TeamSpeakService(
            environ.get('TS3_SERVER_HOST'),
            environ.get('TS3_SERVER_ADMIN'),
            environ.get('TS3_SERVER_ADMIN_PASS')
        )

        client = Client(
            user['name'][:30],
            user.cid,
            user['atc_rating'],
            user['pilot_ratings'][-1] if len(user.pilot_ratings) > 0 else 'P0')

        client = teamspeak.find_client(client)
        teamspeak.register_client(client)
    except TS3QueryError as crap:
        error = crap.resp.error['msg']
        return render_template('public/error-page.html', title=title, error=error)

    return redirect(url_for('dashboard'))

src/website/templates/dashboard/include/base/footer.html
<footer class="sticky-footer bg-white">
    <div class="container my-auto">
        <div class="copyright text-center my-auto">
        <span>Copyright &copy; Portugal vACC 2020</span>
        </div>
    </div>
</footer>

src/website/templates/dashboard/include/base/sidebar-staff.html
<!-- Heading -->
<div class="sidebar-heading">
    Staff Area
</div>
{% if current_user | belongs_to_group('admin', 'staff_editor', 'training_director', 'director') %}
<!-- Government -->
<li class="nav-item">
    <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseGovernment" aria-expanded="true" aria-controls="collapseATCMentoring">
        <i class="fas fa-fw fa-folder"></i>
        <span>Government</span>
    </a>

    <div id="collapseGovernment" class="collapse" aria-labelledby="headingPages" data-parent="#accordionSidebar">
        <div class="bg-white py-2 collapse-inner rounded">
            <a class="collapse-item" href="{{ url_for('members') }}">Manage Certifications</a>
            {% if current_user | belongs_to_group('admin') %}
              <a class="collapse-item" href="{{ url_for('auth.list_users') }}">Authorization Groups</a>
            {% endif %}
        </div>
    </div>
</li>
{% endif %}
{% if current_user | belongs_to_group('admin', 'training_director', 'atcmentor_editor') %}
<!-- ATC Mentoring -->
<li class="nav-item">
    <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseATCMentoring" aria-expanded="true" aria-controls="collapseATCMentoring">
        <i class="fas fa-fw fa-folder"></i>
        <span>ATC Mentoring</span>
    </a>

    <div id="collapseATCMentoring" class="collapse" aria-labelledby="headingPages" data-parent="#accordionSidebar">
        <div class="bg-white py-2 collapse-inner rounded">
            <a class="collapse-item" href="{{ url_for('atcmentoring.mentors_dashboard') }}">Manage Mentors</a>
        </div>
    </div>
</li>
{% endif %}
{% if current_user | belongs_to_group('admin', 'events_editor') %}
<!-- Events Area -->
<li class="nav-item">
    <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseEvents" aria-expanded="true" aria-controls="collapseEvents">
        <i class="fas fa-fw fa-folder"></i>
        <span>Events</span>
    </a>

    <div id="collapseEvents" class="collapse" aria-labelledby="headingPages" data-parent="#accordionSidebar">
        <div class="bg-white py-2 collapse-inner rounded">
            <a class="collapse-item" href="{{ url_for('events.dashboard') }}">Manage Events</a>
        </div>
    </div>
</li>
{% endif %}
{% if current_user | belongs_to_group('admin', 'atcpositions_editor') %}
<!-- RIV Sectors Area -->
<li class="nav-item">
  <a class="nav-link collapsed" href="#" data-toggle="collapse" data-target="#collapseRIVS" aria-expanded="true" aria-controls="collapseRIVS">
      <i class="fas fa-fw fa-folder"></i>
      <span>RIV Sectors</span>
  </a>

  <div id="collapseRIVS" class="collapse" aria-labelledby="headingPages" data-parent="#accordionSidebar">
      <div class="bg-white py-2 collapse-inner rounded">
        <a class="collapse-item" href="{{ url_for('airspace_sectors.riv', riv_id='ae736f03-e13d-42aa-a77e-af348f63efee') }}">LPPC</a>
        <a class="collapse-item" href="{{ url_for('airspace_sectors.riv', riv_id='b7f25ebe-5975-4007-a7e4-f04a135bc3f2') }}">LPPO</a>
      </div>
  </div>
</li>
{% endif %}

src/website/templates/dashboard/include/base/sidebar.html
<!-- Sidebar -->
<ul class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion" id="accordionSidebar">

    <!-- Sidebar - Brand -->
    <a class="sidebar-brand d-flex align-items-center justify-content-center" href="{{ url_for('home') }}">
      <div class="sidebar-brand-icon rotate-n-15">
        <img style="width:42px;" src="{{ url_for('static', filename='img/favicon.png') }}">
      </div>
      <div class="sidebar-brand-text mx-3">Portugal vACC</div>
    </a>

    <hr class="sidebar-divider my-0">

    <li class="nav-item active">
      <a class="nav-link" href="{{ url_for('dashboard') }}">
        <i class="fas fa-fw fa-tachometer-alt"></i>
        <span>Dashboard</span>
      </a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="{{ url_for('members') }}">
        <i class="fas fa-fw fa-chart-area"></i>
        <span>Members List</span>
      </a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="{{ url_for('controllers.positions') }}">
        <i class="fas fa-fw fa-chart-area"></i>
        <span>ATC Positions</span>
      </a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="{{ url_for('controllers.scheduling') }}">
        <i class="fas fa-fw fa-chart-area"></i>
        <span>ATC Sessions</span>
      </a>
    </li>



    <!-- Controllers Area -->
    {% if current_user.atc_rating not in ['OBS', 'INA']   %}
      <hr class="sidebar-divider">
      <div class="sidebar-heading">Controllers</div>
      <li class="nav-item">
        <a class="nav-link" href="{{ url_for('controllers.newsession') }}">
          <i class="fas fa-fw fa-chart-area"></i>
          <span>Book ATC Session</span>
        </a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="http://atis-pt.herokuapp.com/config", target="_blank">
          <i class="fas fa-fw fa-chart-area"></i>
          <span>ATIS URL Config Tool</span>
        </a>
      </li>
    {% endif %}



    <!-- Staff Area -->
    {% if current_user | belongs_to_group('admin', 'staff_editor', 'training_director', 'events_editor', 'atcpositions_editor', 'director', 'send_mail', 'atcmentor_editor') %}
      <hr class="sidebar-divider">
      {% include 'dashboard/include/base/sidebar-staff.html' %}
    {% endif %}



    <!-- ATC Mentoring Area -->
    {% if current_user | belongs_to_group('admin', 'mentor') %}
      <hr class="sidebar-divider">
      <div class="sidebar-heading">Mentor Area</div>
      <li class="nav-item">
        <a class="nav-link" href="{{ url_for('atcmentoring.trainees') }}">
          <i class="fas fa-fw fa-chart-area"></i>
          <span>Trainees</span>
        </a>
      </li>
    {% endif %}



    <!-- Sidebar Toggle -->
    <div class="text-center d-none d-md-inline">
      <button class="rounded-circle border-0" id="sidebarToggle"></button>
    </div>

  </ul>

src/website/templates/dashboard/include/base/topbar-userinfo.html
<style>
  .round {
      font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
      border-radius: 50%;
  }
</style>
<!-- Nav Item - User Information -->
<li class="nav-item dropdown no-arrow mx-1">
  <a class="nav-link">
      <i class="vatsim-rating {{current_user.atc_rating.lower()}}"></i>
      {% for rating in current_user.pilot_ratings %}
        <i class="fa-fw vatsim-rating {{rating.lower()}}"></i>
      {% endfor %}
  </a>
</li>
<div class="topbar-divider d-none d-sm-block"></div>
<li class="nav-item dropdown no-arrow">
  <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      <span class="mr-2 d-none d-lg-inline text-gray-600 small">{{current_user.cid}} - {{current_user.name}}</span>
      <img class="round" width="42" height="42" avatar="{{ current_user.name }}">
  </a>
  <!-- Dropdown - User Information -->
  <div class="dropdown-menu dropdown-menu-right shadow animated--grow-in" aria-labelledby="userDropdown">
      <a class="dropdown-item" href="{{ url_for('profile') }}">
      <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
      Profile
      </a>
      <div class="dropdown-divider"></div>
      <a class="dropdown-item"
        href="#"
        data-toggle="modal"
        data-target="#registerTeamspeakModal">Teamspeak Registration</a>
      <div class="dropdown-divider"></div>
      <a class="dropdown-item"
        href="#"
        data-toggle="modal"
        data-target="#registerDiscordModal">Discord Registration</a>
      <div class="dropdown-divider"></div>
      <a class="dropdown-item" href="#" data-toggle="modal" data-target="#logoutModal">
      <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
      Logout
      </a>
  </div>
</li>

<!-- registerTeamspeakModal Modal-->
<form id="registerTeamspeakForm" action="{{url_for('teamspeak.register', cid=current_user.cid)}}" method="POST">
  <div class="modal fade" id="registerTeamspeakModal" tabindex="-1" role="dialog" aria-labelledby="registerTeamspeakModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="registerTeamspeakModalLabel">TeamSpeak3 Account Resgistration</h5>
                <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <div style="margin:20px">
                <p>For register on Teamspeak you must login first onto the server:</p>
                <div style="margin:20px">
                    <code>
                        <b>
                            <p>Server: ts.portugal-vacc.org</p>
                            <p>Port: Leave blank</p>
                            <p>Nickname: {{current_user.name}}</p>
                        </b>
                    </code>
                </div>
                <p>After logging in you will be in the Entrance room.</p>
                <p>Now you can click <b><i>Perform Registration</i></b>.</p>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
              <input  class="btn btn-primary" style="color: #f8f9fc;" type="submit" value="Perform Registration"></input>
            </div>
        </div>
      </div>
  </div>
</form>
<!-- registerDiscordModal Modal-->
<div class="modal fade" id="registerDiscordModal" tabindex="-1" role="dialog" aria-labelledby="registerDiscordModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title" id="registerDiscordModalLabel">Discord Account Resgistration</h5>
            <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">×</span>
            </button>
        </div>
        <div style="margin:20px">
            <p>For register on Discord follow next steps:</p>
            <div style="margin:20px">
                <code>
                    <b>
                        <p>Join Server: <a href="https://discord.gg/hHgwzRf">https://discord.gg/hHgwzRf</a></p>
                        <p>Execute this command on discord:</p>
                        !vacc-registerme {{ discord_reg_token }}
                    </b>
                </code>
            </div>
        </div>
        <div class="modal-footer">
        <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
        </div>
    </div>
  </div>
</div>
<!-- VATSIM CLIENT Modal-->

<div class="modal fade" id="clientEventModal" tabindex="-1" role="dialog" aria-labelledby="clientEventModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
      <div class="modal-content">
      <div class="modal-header">
          <h5 class="modal-title" id="clientEventModalLabel">Do you want delete this event?</h5>
          <button class="close" type="button" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
          </button>
      </div>
      <div class="modal-body">
          <!--Google map-->
          <div id="googleMap" style="width:100%;height:400px;"></div>
      </div>
      </div>
  </div>
</div>
<script src="{{ url_for('static', filename='js/atcpolygons.js') }}"></script>
<script>
  function myMap(center, marker, line) {
      var mapProp= {
          center:center,
          zoom:4,
          mapTypeId: 'satellite'
      };
      var map = new google.maps.Map(document.getElementById("googleMap"),mapProp);
      if(marker){
          marker.setMap(map);
      }
      if(line){
          line.setMap(map)
      }
  }
  function check_vatsim_conn(){
      const xhr = new XMLHttpRequest();
      xhr.open('GET', 'https://vatsim-api.flyatlantic-va.com/clients?where=cid=="{{current_user.cid}}"', true);
      xhr.onload = function () {
          const result = JSON.parse(xhr.response)['_items'];
          if (result.length > 0){
              document.getElementById('online_text').innerText = "Online as " + result[0].callsign + " (" + result[0].clienttype + ")"
              document.getElementById('clientEventModalLabel').innerText = result[0].callsign + " from " + result[0].planned_depairport + " to " + result[0].planned_destairport
              var btn = document.getElementById('btnonlinestatus')
              btn.style = "color:green; background-color: transparent; border: none;"
              if(result[0].clienttype == 'PILOT'){
                  var client_position = new google.maps.LatLng(result[0].location[1], result[0].location[0])
                  var symbol = {
                      path: 'M362.985,430.724l-10.248,51.234l62.332,57.969l-3.293,26.145 l-71.345-23.599l-2.001,13.069l-2.057-13.529l-71.278,22.928l-5.762-23.984l64.097-59.271l-8.913-51.359l0.858-114.43 l-21.945-11.338l-189.358,88.76l-1.18-32.262l213.344-180.08l0.875-107.436l7.973-32.005l7.642-12.054l7.377-3.958l9.238,3.65 l6.367,14.925l7.369,30.363v106.375l211.592,182.082l-1.496,32.247l-188.479-90.61l-21.616,10.087l-0.094,115.684',
                      fillColor: '#FF0000',
                      fillOpacity: 1.0,
                      anchor: new google.maps.Point(result[0].location[1], result[0].location[0]),
                      strokeWeight: 0,
                      scale: 0.05,
                      rotation: Number(result[0].heading)
                  }
                  var marker = new google.maps.Marker({
                      position: client_position,
                      title: result[0].callsign + " - " + result[0].realname,
                      icon: symbol
                  });

                  var route = Array()
                  result[0].location_history['coordinates'].forEach(element => {
                      route.push({
                          lat:element[1],
                          lng:element[0]
                      })
                  });

                  var line = new google.maps.Polyline({
                      path: route,
                      geodesic: true,
                      strokeColor: '#FF0000',
                      strokeOpacity: 1.0,
                      strokeWeight: 2
                  });
                  myMap(
                      client_position,
                      marker,
                      line)
              }
              if(result[0].clienttype == 'ATC'){
                  var client_position = new google.maps.LatLng(result[0].location[1], result[0].location[0])
                  var coords = POLYGONS[result[0].callsign]['coordinates']
                  var marker = new google.maps.Polygon({
                          paths: coords,
                          strokeColor: '#FF0000',
                          strokeOpacity: 0.8,
                          strokeWeight: 2,
                          fillColor: '#FF0000',
                          fillOpacity: 0.35
                      });

                  myMap(
                      client_position,
                      marker,
                      null)
              }
          }
          else{
              var btn = document.getElementById('btnonlinestatus')
              var text = document.getElementById('online_text')
              text.innerText = "Disconnected from VATSIM"
              btn.style = "color:blue; background-color: transparent; border: none;"
              btn.dataset.target=""
          }
      }
      xhr.send(null);
  }
  this.check_vatsim_conn()

  setInterval(function() {
      this.check_vatsim_conn()
  }, 60 * 1000); // 60 seg

  (function(w, d){


      function LetterAvatar (name, size) {

          name  = name || '';
          size  = size || 60;

          var colours = [
                  "#1abc9c", "#2ecc71", "#3498db", "#9b59b6", "#34495e", "#16a085", "#27ae60", "#2980b9", "#8e44ad", "#2c3e50",
                  "#f1c40f", "#e67e22", "#e74c3c", "#ecf0f1", "#95a5a6", "#f39c12", "#d35400", "#c0392b", "#bdc3c7", "#7f8c8d"
              ],

              nameSplit = String(name).toUpperCase().split(' '),
              initials, charIndex, colourIndex, canvas, context, dataURI;


          if (nameSplit.length == 1) {
              initials = nameSplit[0] ? nameSplit[0].charAt(0):'?';
          } else {
              initials = nameSplit[0].charAt(0) + nameSplit[1].charAt(0);
          }

          if (w.devicePixelRatio) {
              size = (size * w.devicePixelRatio);
          }

          charIndex     = (initials == '?' ? 72 : initials.charCodeAt(0)) - 64;
          colourIndex   = charIndex % 20;
          canvas        = d.createElement('canvas');
          canvas.width  = size;
          canvas.height = size;
          context       = canvas.getContext("2d");

          context.fillStyle = colours[colourIndex - 1];
          context.fillRect (0, 0, canvas.width, canvas.height);
          context.font = Math.round(canvas.width/2)+"px Arial";
          context.textAlign = "center";
          context.fillStyle = "#FFF";
          context.fillText(initials, size / 2, size / 1.5);

          dataURI = canvas.toDataURL();
          canvas  = null;

          return dataURI;
      }

      LetterAvatar.transform = function() {

          Array.prototype.forEach.call(d.querySelectorAll('img[avatar]'), function(img, name) {
              name = img.getAttribute('avatar');
              img.src = LetterAvatar(name, img.getAttribute('width'));
              img.removeAttribute('avatar');
              img.setAttribute('alt', name);
          });
      };


      // AMD support
      if (typeof define === 'function' && define.amd) {

          define(function () { return LetterAvatar; });

      // CommonJS and Node.js module support.
      } else if (typeof exports !== 'undefined') {

          // Support Node.js specific `module.exports` (which can be a function)
          if (typeof module != 'undefined' && module.exports) {
              exports = module.exports = LetterAvatar;
          }

          // But always support CommonJS module 1.1.1 spec (`exports` cannot be a function)
          exports.LetterAvatar = LetterAvatar;

      } else {

          window.LetterAvatar = LetterAvatar;

          d.addEventListener('DOMContentLoaded', function(event) {
              LetterAvatar.transform();
          });
      }

  })(window, document);
</script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDj4y39JAORYGw4rNcA1y8oVj0m8lNDje4&callback=myMap"></script>

src/website/templates/dashboard/include/base/topbar.html
<!-- Topbar -->
<nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
  <!-- Sidebar Toggle (Topbar) -->
  <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
    <i class="fa fa-bars"></i>
  </button>

  <!-- Topbar Navbar -->
  <ul class="navbar-nav ml-auto">
    <!-- Nav Item - Alerts -->


    <!-- Nav Item - Messages -->


    <div class="topbar-divider d-none d-sm-block"></div>

    <!-- Nav Item - User Information -->
    {% include 'dashboard/include/base/topbar-userinfo.html' %}
  </ul>
</nav>
<!-- End of Topbar -->
<!-- Logout Modal-->
<div class="modal fade" id="logoutModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
<div class="modal-dialog" role="document">
  <div class="modal-content">
    <div class="modal-header">
      <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
      <button class="close" type="button" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">×</span>
      </button>
    </div>
    <div class="modal-body">Select "Logout" below if you are ready to end your current session.</div>
    <div class="modal-footer">
      <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
      <a class="btn btn-primary" href="{{ url_for('auth.logout') }}">Logout</a>
    </div>
  </div>
</div>
</div>